Subject: Re: [RFC v2 00/10] HFI Virtual Network Interface Controller (VNIC)

From: Jason Gunthorpe <jgunthorpe-ePGOBjL8dl3ta4EC/59zMFaTQe2KTcn/@public.gmane.org>
Date: Thu, 15 Dec 2016 11:48:37 -0700

On Thu, Dec 15, 2016 at 01:19:18PM -0500, Doug Ledford wrote:
> On 12/15/2016 12:07 PM, Jason Gunthorpe wrote:
> > On Thu, Dec 15, 2016 at 11:28:06AM -0500, Doug Ledford wrote:
> > 
> >> 1) Since your intent is to make this work with multiple versions of the
> >> hfi drivers, I disagree with Jason that just because there is only one
> >> driver today that we should keep it simple.  Design it right from the
> >> beginning of multi driver is your intent is, IMO, a better way to go.
> >> You'll work out the bugs in the initial implementation and when it comes
> >> time to add the second driver, things will go much more smoothly.
> > 
> > If that is your position then this should be a straight up IB ULP that
> > works with any IB hardware.
> 
> Yes, see my comments in point #3 of my previous email...

Well, I'm not opposed to the vnic idea - Mellanox had (has?) a similar
IB driver. There are lots of good reasons to strictly maintain the
ethernet presentation.

There is much more going on here than just changing the LLADDR,
essentially everything MAD focused is different compared to ipoib, and
it looks like the required datastructures are different too. This is
more of a map a mac to a OPA_LRH approach with SA mediated discovery,
by my eye.

The main share is the 'skb send' part, we've talked about hoisting
that out of ipoib in the past anyhow. A generic verb along those lines
would probably allow the sdma optimization for hfi for both this new
ulp and ipoib without creating such an ugly HFI1 specific interface.

Jason
--
To unsubscribe from this list: send the line "unsubscribe linux-rdma" in
the body of a message to [email-masked]
More majordomo info at  http://vger.kernel.org/majordomo-info.html